<template>
  <div :class="['album-list-item-sidebarview', { 'album-list-item-sidebarview--active': active }]">
    <a href="javascript:;" @click="onClick">
      <img :src="thumb" :alt="album.displayName" :title="album.displayName" />
      <div class="album-list-item-sidebarview__outline" :title="album.displayName"></div>
    </a>
  </div>
</template>

<script>
const NO_IMAGE_THUMB = '/images/layout/no-image.png'

import { computed } from 'vue'
import { useApi } from '../../core'
import ImageHelper from '../lib/image-helper.js'

export default {
  name: 'AlbumsListItemSidebarView',
  emits: ['albumSelected'],
  props: {
    album: { type: Object, required: true },
    active: { type: Boolean, default: false },
    managing: { type: Boolean, default: false }, // Not used in sidebar view
  },
  setup(props, context) {
    const api = useApi()

    const thumb = computed(() => {
      return props.album.image
        ? ImageHelper.getImageUrl(api.storageBaseUrl, props.album.image, 'thumb')
        : NO_IMAGE_THUMB
    })

    const onClick = () => {
      context.emit('albumSelected', props.album)
    }

    return {
      thumb,
      onClick,
    }
  },
}
</script>

<style lang="scss">
@use '../../core/sass/vars';

.album-list-item-sidebarview > a {
  display: block;
  width: calc(vars.$galleryThumbWidth / 2);
  height: calc(vars.$galleryThumbWidth / 2);
  margin-bottom: vars.$gallerySpacing;
  position: relative;
}

.album-list-item-sidebarview > a > img {
  width: calc(vars.$galleryThumbWidth / 2);
  height: calc(vars.$galleryThumbWidth / 2);
  background-color: vars.$panelColor;
  border-radius: calc(vars.$galleryBorderRadius / 2);
}

.album-list-item-sidebarview__outline {
  display: none;
}

.album-list-item-sidebarview--active .album-list-item-sidebarview__outline {
  display: block;
  position: absolute;
  top: 0;
  left: 0;
  bottom: 0;
  right: 0;
  border: vars.$galleryBorderThickness solid vars.$linkColor;
  border-radius: calc(vars.$galleryBorderRadius / 2);
}

// Larger displays
@media only screen and (min-width: vars.$sm) {
  .album-list-item-sidebarview > a {
    width: calc(vars.$galleryThumbWidthLarge / 2);
    height: calc(vars.$galleryThumbWidthLarge / 2);
    margin-bottom: vars.$gallerySpacingLarge;
  }

  .album-list-item-sidebarview > a > img {
    width: calc(vars.$galleryThumbWidthLarge / 2);
    height: calc(vars.$galleryThumbWidthLarge / 2);
    border-radius: calc(vars.$galleryBorderRadiusLarge / 2);
  }

  .album-list-item-sidebarview--active .album-list-item-sidebarview__outline {
    border-width: vars.$galleryBorderThicknessLarge;
    border-radius: calc(vars.$galleryBorderRadiusLarge / 2);
  }
}

.dark {
  .album-list-item-sidebarview--active .album-list-item-sidebarview__outline {
    border-color: vars.$darkLinkColor;
  }

  .album-list-item-sidebarview > a > img {
    background-color: vars.$darkPanelColor;
  }
}
</style>
